public class MoveToBorder extends AbstractStrategy{
    @Override
    protected boolean IsTargetDestination() {
        var objParams = getObjectParameters.get();
        if(objParams == null)
            return false;
        return objParams.getRightBorder() + GetStep() >= getFieldWidth() &&
                objParams.getDownBorder() + GetStep() >= getFieldHeight();
    }
    @Override
    protected void MoveToTarget() {
        var objParams = getObjectParameters.get();
        if(objParams == null)
            return;
        var diffX = objParams.getRightBorder() - getFieldWidth();
        var diffY = objParams.getDownBorder() - getFieldHeight();
        if(diffX >= 0)
        {
            MoveDown();
        }
        else if(diffY >= 0)
        {
            MoveRight();
        }
        else if(Math.abs(diffX) > Math.abs(diffY))
        {
            MoveRight();
        }
        else
        {
            MoveDown();
        }
    }
}
